import numpy as np

def J_BAD(u, m, x0, h):
    N = len(u)

    # forward sweep
    X = np.zeros(N)
    X[0] = x0
    for i in range(N-1):
        X[i+1] = X[i] + h * ((1 - X[i]) * X[i] + u[i])

    J = np.zeros((m,N))

    for mm in range(m):
        # initialize bar quantities
        ubar = np.zeros(N)
        xbar = np.zeros(N)
        xbar[N-mm-1] = 1

        # backward sweep
        for i in range(N-1, 0, -1):
            dfdu = h
            dfdx = 1 + h * (1 - 2 * X[i])
            ubar[i] = ubar[i] + xbar[i] * dfdu 
            xbar[i-1] = xbar[i-1] + xbar[i] * dfdx 

        # x1 = f(x0,u)
        ubar[0] = ubar[0] + xbar[0] * h

        J[m-mm-1,:] = ubar.T
    return J
